#if !defined( _JLetterCounterObj_h )
#define _JLetterCounterObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"



#define NUMBER_ROWS 36
#define MAX_COLS 100

class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JLetterCounterObj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      TEXT };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JLetterCounterObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual int inputType( int n );
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
virtual void paint(JGraphics g, double dx, double dy, JRegion& rgn, double scale);
  private:
	  int history[36][MAX_COLS];
	  int currentHistoryColumn;  // values 0-9, first used in display
	  int currentCount;
	  void broadcastCounts();
	  void shiftHistory();
	  void initCounts();
	  void initHistory();

	  void processText();
	  void processChar( char x );
	  void process_AZ( int val );
	  void process_09( int val );

	  int totalCount;

    // inputs
    JString text;

    // properties
    int numberColumns;
    int valuesPerChunk;
    int onThreshhold;
    JColor onColor;
    JColor offColor;

    // outputs
    int letterCounts[26];
	int digitCounts[10];
};


#endif
