#include "JMatcherObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJMatcherObj = JMatcherObj().Register();


void JMatcherObj::writeContent(JOutputStream& os) {
  JAddObj::writeContent(os);
  putObject(os, "m1in", m1in);
  putObject(os, "m2in", m2in);
  putObject(os, "m3in", m3in);
  putObject(os, "m4in", m4in);
  putObject(os, "m5in", m5in);
  putObject(os, "m6in", m6in);
  putObject(os, "m7in", m7in);
  putObject(os, "m8in", m8in);
  putObject(os, "m9in", m9in);
  putObject(os, "m10in", m10in);
}

void JMatcherObj::readContent(JDictionary& dict) {
  JAddObj::readContent(dict);
  JObject* obj_m1in = getObject( dict, "m1in");
  if ( obj_m1in ) m1in = *(JString*)obj_m1in;
  JObject* obj_m2in = getObject( dict, "m2in");
  if ( obj_m2in ) m2in = *(JString*)obj_m2in;
  JObject* obj_m3in = getObject( dict, "m3in");
  if ( obj_m3in ) m3in = *(JString*)obj_m3in;
  JObject* obj_m4in = getObject( dict, "m4in");
  if ( obj_m4in ) m4in = *(JString*)obj_m4in;
  JObject* obj_m5in = getObject( dict, "m5in");
  if ( obj_m5in ) m5in = *(JString*)obj_m5in;
  JObject* obj_m6in = getObject( dict, "m6in");
  if ( obj_m6in ) m6in = *(JString*)obj_m6in;
  JObject* obj_m7in = getObject( dict, "m7in");
  if ( obj_m7in ) m7in = *(JString*)obj_m7in;
  JObject* obj_m8in = getObject( dict, "m8in");
  if ( obj_m8in ) m8in = *(JString*)obj_m8in;
  JObject* obj_m9in = getObject( dict, "m9in");
  if ( obj_m9in ) m9in = *(JString*)obj_m9in;
  JObject* obj_m10in = getObject( dict, "m10in");
  if ( obj_m10in ) m10in = *(JString*)obj_m10in;
}

const char* JMatcherObj::className() const { return "JMatcherObj";}


JObject* JMatcherObj::clone() const { return new JMatcherObj(*this);}


// class constructor
JMatcherObj::JMatcherObj() {
  igm = 1;
  ogm = 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1;
m1 = m2 = m3 = m4 = m5 = m6 = m7 = m8 = m9 = m10= 0;
}


void JMatcherObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("Match"), rect);
}


boolean JMatcherObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JMatcherObj::inputTag(int n) {
  char* tag[] = {
    "text" };
  return( tag[n] );
}


int JMatcherObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JMatcherObj::outputTag(int n) {
  char* tag[] = {
    "m1",
    "m2",
    "m3",
    "m4",
    "m5",
    "m6",
    "m7",
    "m8",
    "m9",
    "m10" };
  return( tag[n] );
}


JFRect JMatcherObj::inputArea(int n) {
  //if ( n < ( 1 )) {
    return leftArea( n, 0, 1, 0.1, 0.8 );
 // }
}


JFRect JMatcherObj::outputArea(int n) {
  return rightArea(n, 0, 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1);
}


int JMatcherObj::inputFace(int n) {
  if ( n < 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JMatcherObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JMatcherObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1, 0.1, 0.8);
}


JFPoint JMatcherObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1);
}


void JMatcherObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    INT(data) = m1;
  } else if ( n == 1 ) {
    INT(data) = m2;
  } else if ( n == 2 ) {
    INT(data) = m3;
  } else if ( n == 3 ) {
    INT(data) = m4;
  } else if ( n == 4 ) {
    INT(data) = m5;
  } else if ( n == 5 ) {
    INT(data) = m6;
  } else if ( n == 6 ) {
    INT(data) = m7;
  } else if ( n == 7 ) {
    INT(data) = m8;
  } else if ( n == 8 ) {
    INT(data) = m9;
  } else if ( n == 9 ) {
    INT(data) = m10;
  }
}

#include <string.h>

void JMatcherObj::engine(int n, JLinkObj& link) {
	char* scanner;
  switch (n) {
  case TEXT:
    link.access( JStringData( text ));
	scanner= text;
	if ( strstr( text, m1in ) != NULL ) {
		m1++;
		broadcast( 0 );
	}
	if ( strstr( text, m2in ) != NULL ) {
		m2++;
		broadcast( 1 );
	}
	if ( strstr( text, m3in ) != NULL ) {
		m3++;
		broadcast( 2 );
	}
	if ( strstr( text, m4in ) != NULL ) {
		m4++;
		broadcast( 3 );
	}
	if ( strstr( text, m5in ) != NULL ) {
		m5++;
		broadcast( 4 );
	}
	if ( strstr( text, m6in ) != NULL ) {
		m6++;
		broadcast( 5 );
	}
	if ( strstr( text, m7in ) != NULL ) {
		m7++;
		broadcast( 6 );
	}
	if ( strstr( text, m8in ) != NULL ) {
		m8++;
		broadcast( 7 );
	}
	if ( strstr( text, m9in ) != NULL ) {
		m9++;
		broadcast( 8 );
	}
	if ( strstr( text, m10in ) != NULL ) {
		m10++;
		broadcast( 9 );
	}
    break;
  default:
    break;
  }
}


JArray JMatcherObj::getProperties() {
  JArray properties;
  properties.append(JStringProperty("m1in", m1in));
  properties.append(JStringProperty("m2in", m2in));
  properties.append(JStringProperty("m3in", m3in));
  properties.append(JStringProperty("m4in", m4in));
  properties.append(JStringProperty("m5in", m5in));
  properties.append(JStringProperty("m6in", m6in));
  properties.append(JStringProperty("m7in", m7in));
  properties.append(JStringProperty("m8in", m8in));
  properties.append(JStringProperty("m9in", m9in));
  properties.append(JStringProperty("m10in", m10in));
  return properties;
}


boolean JMatcherObj::updateProperty(JProperty& prop) {
  if (prop.getName() == JString("m1in")) {
    m1in = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("m2in")) {
    m2in = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("m3in")) {
    m3in = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("m4in")) {
    m4in = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("m5in")) {
    m5in = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("m6in")) {
    m6in = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("m7in")) {
    m7in = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("m8in")) {
    m8in = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("m9in")) {
    m9in = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("m10in")) {
    m10in = ((JStringProperty*)&prop)->value;
    return true;
  }
  return false;
}


