#include "JWordMakerObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJWordMakerObj = JWordMakerObj().Register();


const char* JWordMakerObj::className() const { return "JWordMakerObj";}


JObject* JWordMakerObj::clone() const { return new JWordMakerObj(*this);}


// class constructor
JWordMakerObj::JWordMakerObj() {
  igm = 1;
  ogm = 1;
}


void JWordMakerObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("Words"), rect);
}


boolean JWordMakerObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JWordMakerObj::inputTag(int n) {
  char* tag[] = {
    "text" };
  return( tag[n] );
}


int JWordMakerObj::outputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
int JWordMakerObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JWordMakerObj::outputTag(int n) {
  char* tag[] = {
    "word" };
  return( tag[n] );
}


JFRect JWordMakerObj::inputArea(int n) {
  //if ( n < ( 1 )) {
    return leftArea( n, 0, 1, 0.1, 0.8 );
  //}
}


JFRect JWordMakerObj::outputArea(int n) {
  return rightArea(n, 0, 1);
}


int JWordMakerObj::inputFace(int n) {
  if ( n < 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JWordMakerObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JWordMakerObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1, 0.1, 0.8);
}


JFPoint JWordMakerObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1);
}


void JWordMakerObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    JSTRING(data) = word;
  }
}

#include <stdio.h>
#include <malloc.h>
#include <string.h>
char* newstrcpy( char* s ) {
	char* result = (char*)malloc( strlen( s ) + 1 );
	strcpy( result, s );
	return( result );
}

void JWordMakerObj::engine(int n, JLinkObj& link) {
	char* scanner;
	char* start;
	char* end;
	char* outScanner = &wordBuf[0];
  switch (n) {
  case TEXT:
    link.access( JStringData( text ));
	strncpy( &wordBuf[0], text, 9999 );
	wordBuf[9999] = 0;
	start = &wordBuf[0];
	scanner = &wordBuf[0];
	// zero out non alphas
	while ( *scanner ) {
		if (( *scanner >= 'a' ) && ( *scanner <= 'z' )) {
			// its ok
		} else if (( *scanner >= 'A' ) && ( *scanner <= 'Z' )) {
			// its ok
		} else {
			*scanner = 0;
		}
		scanner++;
	}
	end = scanner;
	start = &wordBuf[0];
	while ( start < end ) {
		if ( *start ) {
			///char dbuf[100];
			//sprintf( dbuf, "found word %s", start );
			//JComponent::debug( newstrcpy( dbuf ));
			word = JString( start, 2 );
			broadcast( 0 );
			while ( *start ) {
				start++;
			}
		} else {
			start++;
		}
	}
    break;
  default:
    break;
  }
}


